Attribute VB_Name = "Mod_Plat1_Ausg"
Option Explicit

Public Text1 As String, Text2 As String, Zahl As String, Einheit As String
Public aTab(0 To 10) As Integer, Tab0 As Integer
Public strZ(0 To 10) As String
Public p As Object

Public Sub Drucken()
Dim x As Single, y As Single
Dim ix As Integer, iy As Integer
Dim Zeile As Integer, Seite As Integer

With frm_Plat1.CommonDialog1
  .CancelError = False
  On Error GoTo MErrDr_Nachw
  .ShowPrinter
End With

Set p = Printer
With p
  Call Tabulatoren
  p.ScaleMode = 6              'in mm
  p.FontName = "arial"         'geht (jedoch ohne Tabs)

  p.FontSize = 15
  p.FontBold = True
  p.CurrentX = Tab0
  p.CurrentY = Tab0
  p.Print "Programm " + strPgmName + ", Version " + strVersion
  p.Print

  'Eingaben - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  p.FontSize = 15
  p.FontBold = True
  p.CurrentX = Tab0
  p.Print "*** Eingaben ***"
  p.Print

  p.FontSize = 12
  p.FontBold = False
  p.CurrentX = Tab0: p.Print "E-Modul ";
  p.CurrentX = aTab(3): p.Print "E = " + Format(EMod, "scientific") + " kN/m"

  p.CurrentX = Tab0: p.Print "Plattendicke ";
  p.CurrentX = aTab(3): p.Print "t = " + Format(t, "#0.000 m")

  p.CurrentX = Tab0
  p.Print "Querdehnzahl ";
  p.CurrentX = aTab(3):  p.Print "mue = " + Format(mue, "#0.000")
  p.Print

  p.CurrentX = Tab0: p.Print "Belastung ";
  p.CurrentX = aTab(3): p.Print "pz = " + Format(pz, "#0.000 kN/m")
  p.Print

  p.CurrentX = Tab0: p.Print "Plattenseitenlnge ";
  p.CurrentX = aTab(3): p.Print "lx = "; lx; " m";
  p.CurrentX = aTab(4): p.Print "ly = "; ly; " m"
  p.Print

  p.CurrentX = Tab0: p.Print "Seitenlnge Belastung";
  p.CurrentX = aTab(3): p.Print "c = "; c; " m";
  p.CurrentX = aTab(4): p.Print "d = "; d; " m"
  p.Print

  p.CurrentX = Tab0: p.Print "Belastungsmittelpunkt";
  p.CurrentX = aTab(3): p.Print "u = "; u; " m";
  p.CurrentX = aTab(4): p.Print "v = "; v; " m"
  p.Print

  p.CurrentX = Tab0: p.Print "Zahl der Reihenglieder ";
  p.CurrentX = aTab(3): p.Print "nx = "; nx;
  p.CurrentX = aTab(4): p.Print "ny = "; ny

  p.CurrentX = Tab0: p.Print "Zahl der Ausgabestellen ";
  p.CurrentX = aTab(3): p.Print "nzx = "; nzx;
  p.CurrentX = aTab(4): p.Print "nzy = "; nzy
  p.Print

  'Ergebnisse - - - - - - - - - - - - - - - - - - - - - - - -
  p.FontSize = 15
  p.FontBold = True
  p.CurrentX = Tab0
  p.Print "*** Ergebnisse ***"
  p.Print

  p.FontSize = 12
  p.FontBold = False
  
  Zeile = 0: Seite = 1
  Call Dr_Ueberschrift
  For ix = 1 To nzx
    x = (ix - 1) * dx
    p.FontSize = 4
    p.Print
    p.FontSize = 12
    For iy = 1 To nzy
      y = (iy - 1) * dy
      If iy = 1 Then strZ(0) = Format(x, "#0.00")
      strZ(1) = Format(y, "#0.00")
      strZ(2) = Format(WZ(iy, ix) * 1000, "#0.000")
      strZ(3) = Format(MX(iy, ix), "#0.000")
      strZ(4) = Format(MY(iy, ix), "#0.000")
      strZ(5) = Format(MXY(iy, ix), "#0.000")
      strZ(6) = Format(QX(iy, ix), "#0.000")
      strZ(7) = Format(QY(iy, ix), "#0.000")
      Call TabZahlDr(7, 1, p)
      Zeile = Zeile + 1
      If Seite = 1 And Zeile = 28 Then
        p.NewPage
        Zeile = 0: Seite = 2
        p.CurrentX = Tab0: p.CurrentY = Tab0
        p.Print "Programm " + strPgmName + ", Seite " + Str(Seite): p.Print
        Call Dr_Ueberschrift
      End If
      If Seite > 1 And Zeile = 45 Then
        p.NewPage
        Zeile = 0: Seite = Seite + 1
        p.CurrentX = Tab0: p.CurrentY = Tab0
        p.Print "Programm " + strPgmName + ", Seite " + Str(Seite): p.Print
        Call Dr_Ueberschrift
      End If
    Next iy
  Next ix

  p.EndDoc           'Dokument drucken
End With

Exit Sub

MErrDr_Nachw:
  MsgBox "Die Ausgabe konnte nicht gedruckt werden.", , "Hinweis"
  Resume Next
  
End Sub

Public Sub TabZahlDr(ByVal Zahl As Integer, ByVal ZU As Integer, ByVal p As Object)
'rechtsbndige Ausgabe der Zahlen i2 und Zahl(NE), ggf. mit Einheit auf Drucker
'Zahl = Anzahl der Tabellenelemente (Spalten)
'ZU = 1 Zeilenumbruch, = 0 kein Zeilenumbruch
'Public:
'aTab( )= Position der Spalten
'strZ( )= Inhalt der Spalten

Dim j1 As Integer

p.CurrentX = Tab0              '1. Spalte linsbndig
p.Print strZ(0);

For j1 = 1 To Zahl             'weitere Spalten rechtsbndig
  p.CurrentX = aTab(j1) - p.TextWidth(strZ(j1))
  p.Print strZ(j1);
Next j1

If ZU > 0 Then p.Print
If ZU > 1 Then p.Print

End Sub   'TabZahlDr

Public Sub Tabulatoren()
  Tab0 = 20                    'linker Rand 20 mm
  aTab(0) = 25                 '  eingerckter Text
  aTab(1) = 40                 '  eingerckter Text
  aTab(2) = 55                 'Beginn Variable, rechtsbndig
  aTab(3) = 80                'Zahl, rechtsbndig
  aTab(4) = 105                'Zahl, rechtsbndig
  aTab(5) = 130                'Zahl, rechtsbndig
  aTab(6) = 155                'Zahl, rechtsbndig
  aTab(7) = 180                'Zahl, rechtsbndig
End Sub

Public Sub Dr_Ueberschrift()
  'berschrift auf neue Seite
  strZ(0) = "x"
  strZ(1) = "y"
  strZ(2) = "w"
  strZ(3) = "mx"
  strZ(4) = "my"
  strZ(5) = "mxy"
  strZ(6) = "qx"
  strZ(7) = "qy"
  Call TabZahlDr(7, 1, p)
  strZ(0) = strEHL
  strZ(1) = strEHL
  strZ(2) = "mm"
  strZ(3) = strEHF + strEHL + "/" + strEHL
  strZ(4) = strEHF + strEHL + "/" + strEHL
  strZ(5) = strEHF + strEHL + "/" + strEHL
  strZ(6) = strEHF + "/" + strEHL
  strZ(7) = strEHF + "/" + strEHL
  Call TabZahlDr(7, 1, p)
End Sub

Public Sub EingPr(ByVal Eing1 As String, Wert1)
  'Eingabeprfung
  Dim Stelle As Integer
  On Error GoTo ErrEingabe
  Stelle = InStr(Eing1, ",")
  If Stelle > 0 Then
    Mid(Eing1, Stelle, 1) = "."
  End If
  If Eing1 = "" Then Eing1 = "0"
  Wert1 = Val(Eing1)
  Exit Sub

ErrEingabe:
  MsgBox ("fehlerhafte Eingabe")
End Sub

