Attribute VB_Name = "Mod_Plat1_Plot"
Option Explicit

Public IP As Integer, PLOT As Integer
Public BX0 As Integer, BY0 As Integer, XR As Integer
Public XA As Single, XE As Single, YA As Single, YE As Single

Public MA As Single, MS As Single
Public zentx As Integer, zenty As Integer
Public ZE As Integer, SP As Integer
Public FarbeS As Long, FarbeZ As Long, FarbeV As Long, FarbeW As Long
Public xP() As Single, yP() As Single
Public AZ() As Single
Public xPTa As Single, xPTe As Single, yPTa As Single, yPTe As Single
Public xPTa1 As Single, xPTe1 As Single
Public xPTa2 As Single, xPTe2 As Single     '5.1
Public Verx As Single, Very As Single

Public p As Object

Public Sub Start_Plotten(ByVal PLOT As Integer, ByVal IP As Integer)
Dim ix As Integer, iy As Integer
Dim XX As Integer, YY As Integer
Dim EX As Single, EY As Single
ReDim xP(nzx + 1, nzy + 1) As Single, yP(nzy + 1, nzy + 1) As Single   '5.1
ReDim AZ(nzx + 1, nzy + 1) As Single                                   '5.1

PLOT = 1

FarbeS = RGB(0, 0, 0)        'System
FarbeZ = RGB(255, 0, 0)      'Schnittgren
FarbeV = RGB(0, 0, 255)      'Querkrfte
FarbeW = RGB(0, 255, 0)      'Biegelinie

Set p = frm_Plat1_Plot.Picture1    'Grafik als Vollbild
p.Cls

BX0 = p.ScaleWidth
BY0 = p.ScaleHeight

XR = BX0 / 10
XX = BX0 - 2 * XR: YY = BY0 - 2 * XR

'Netzkoordinaten transformieren
For ix = 1 To nzx + 1       '5.1
  For iy = 1 To nzy + 1     '5.1
    xP(ix, iy) = (ix - 1) * dx + Verx * (iy - 1) * dy
    yP(ix, iy) = (iy - 1) * dy * Very
  Next iy
Next ix

'Koordinaten Lastrechteck
xPTa = u - c: xPTe = u + c
yPTa = v - d: yPTe = v + d
'Lastrechteck transformieren
xPTa1 = xPTa + Verx * (v - d): xPTe1 = xPTe + Verx * (v - d)   '5.1
xPTa2 = xPTa + Verx * (v + d): xPTe2 = xPTe + Verx * (v + d)   '5.1
yPTa = yPTa * Very: yPTe = yPTe * Very

'Mastab berechnen
XA = 100000!: XE = -XA: YA = 100000!: YE = -YA: 'MV = XE
For ix = 1 To nzx + 1      '5.1
  For iy = 1 To nzy + 1    '5.1
    If XA > xP(ix, iy) Then XA = xP(ix, iy)
    If XE < xP(ix, iy) Then XE = xP(ix, iy)
    If YA > yP(ix, iy) Then YA = yP(ix, iy)
    If YE < yP(ix, iy) Then YE = yP(ix, iy)
  Next iy
Next ix
EX = Abs(XE - XA): If EX = 0 Then EX = 1
EY = Abs(YE - YA): If EY = 0 Then EY = 1
MA = XX / EX: If MA > YY / EY Then MA = YY / EY

'Bildzentrierung
zentx = (XX - EX * MA) / 2: zenty = (YY - EY * MA) / 2

Call Plotten_1(1, IP)

End Sub   'Start_Plotten

Public Sub Plotten_1(ByVal PLOT As Integer, ByVal IP As Integer)
'Bildschirmgrafik
Dim ZE0 As Integer, ZE1 As Integer

ZE0 = CInt(0.45 * BY0): ZE1 = CInt(0.95 * BY0)
ZE = ZE1
SP = 0.05 * BX0

Select Case IP
  Case 1: Call Plotten_Ord(IP, pT)
  Case 2: Call Plotten_Ord(IP, WZ)
  Case 3: Call Plotten_Ord(IP, MX)
  Case 4: Call Plotten_Ord(IP, MY)
  Case 5: Call Plotten_Ord(IP, MXY)
  Case 6: Call Plotten_Ord(IP, QX)
  Case 7: Call Plotten_Ord(IP, QY)
End Select

Call Unterschriften(PLOT, IP)

End Sub   'Plotten_1

Public Sub Plotten_Ord(ByVal IP As Integer, AZ)
'Ordinaten zeichnen
Dim Farbe As Long
Dim ix As Integer, iy As Integer
Dim xPA As Integer, xPE As Integer
Dim yPA As Integer, yPE As Integer

'Linien in x-Richtung
Farbe = FarbeZ
If IP = 1 Or IP = 2 Then Farbe = FarbeW
If IP = 6 Or IP = 7 Then Farbe = FarbeV

p.Cls
Call Plotten_Sys
Call Mastab(IP, AZ)

'Linien in x-Richtung
For ix = 1 To nzx
  For iy = 1 To nzy + 1
     If IP > 2 Then                             '5.1
       Select Case AZ(ix, iy)
              Case Is < -0.00001: Farbe = RGB(255, 0, 0)
              Case Is > 0.00001: Farbe = RGB(0, 0, 255)
              Case Else: Farbe = RGB(0, 0, 0)
       End Select
    End If
    xPA = CInt(XR + MA * (xP(ix, iy) - XA) + zentx)
    yPA = CInt(XR + MA * (yP(ix, iy) - YA) - AZ(ix, iy) * MS + zenty)   '5.1
    xPE = CInt(XR + MA * (xP(ix + 1, iy) - XA) + zentx)
    yPE = CInt(XR + MA * (yP(ix + 1, iy) - YA) - AZ(ix + 1, iy) * MS + zenty)   '5.1
    p.Line (xPA, BY0 - yPA)-(xPE, BY0 - yPE), Farbe
  Next iy
Next ix
'Linien in y-Richtung
For ix = 1 To nzx + 1
  For iy = 1 To nzy
     If IP > 2 Then                             '5.1
       Select Case AZ(ix, iy)
              Case Is < -0.00001: Farbe = RGB(255, 0, 0)
              Case Is > 0.00001: Farbe = RGB(0, 0, 255)
              Case Else: Farbe = RGB(0, 0, 0)
       End Select
    End If
    xPA = CInt(XR + MA * (xP(ix, iy) - XA) + zentx)
    yPA = CInt(XR + MA * (yP(ix, iy) - YA) - AZ(ix, iy) * MS + zenty)   '5.1
    xPE = CInt(XR + MA * (xP(ix, iy + 1) - XA) + zentx)
    yPE = CInt(XR + MA * (yP(ix, iy + 1) - YA) - AZ(ix, iy + 1) * MS + zenty)   '5.1
    p.Line (xPA, BY0 - yPA)-(xPE, BY0 - yPE), Farbe
  Next iy
Next ix
'Ordinaten = vertikale Linien
p.DrawStyle = 2    'Punkte
For ix = 1 To nzx
  For iy = 1 To nzy + 1
     If IP > 2 Then                             '5.1
       Select Case AZ(ix, iy)
              Case Is < -0.00001: Farbe = RGB(255, 0, 0)
              Case Is > 0.00001: Farbe = RGB(0, 0, 255)
              Case Else: Farbe = RGB(0, 0, 0)
       End Select
    End If
    xPA = CInt(XR + MA * (xP(ix, iy) - XA) + zentx)
    yPA = CInt(XR + MA * (yP(ix, iy) - YA) + zenty)
    xPE = CInt(XR + MA * (xP(ix, iy) - XA) + zentx)
    yPE = CInt(XR + MA * (yP(ix, iy) - YA) - AZ(ix, iy) * MS + zenty)   '5.1
    p.Line (xPA, BY0 - yPA)-(xPE, BY0 - yPE), Farbe
  Next iy
Next ix
p.DrawStyle = 0    'Linie

End Sub   'Plotten_Ord

Public Sub Plotten_Sys()
'Raster zeichnen
Dim ix As Integer, iy As Integer
Dim xPA As Integer, xPE As Integer
Dim yPA As Integer, yPE As Integer
Dim xPA1 As Integer, xPE1 As Integer

p.DrawStyle = 2    'gepunktet
For iy = 0 To nzy + 1
  For ix = 0 To nzx
    xPA = CInt(XR + MA * (xP(ix, iy) - XA) + zentx)
    yPA = CInt(XR + MA * (yP(ix, iy) - YA) + zenty)
    xPE = CInt(XR + MA * (xP(ix + 1, iy) - XA) + zentx)
    yPE = CInt(XR + MA * (yP(ix + 1, iy) - YA) + zenty)
    p.Line (xPA, BY0 - yPA)-(xPE, BY0 - yPE), FarbeS
  Next ix
Next iy

For iy = 0 To nzy
  For ix = 0 To nzx + 1
    xPA = CInt(XR + MA * (xP(ix, iy) - XA) + zentx)
    yPA = CInt(XR + MA * (yP(ix, iy) - YA) + zenty)
    xPE = CInt(XR + MA * (xP(ix, iy + 1) - XA) + zentx)
    yPE = CInt(XR + MA * (yP(ix, iy + 1) - YA) + zenty)
    p.Line (xPA, BY0 - yPA)-(xPE, BY0 - yPE), FarbeS
  Next ix
Next iy
p.DrawStyle = 0    'Linie

'Lastrechteck                                 '5.1
If blnLastDarst Then
  p.DrawWidth = 2
  xPTa1 = CInt(XR + MA * (xPTa1 - XA) + zentx)
  xPTa2 = CInt(XR + MA * (xPTa2 - XA) + zentx)
  xPTe1 = CInt(XR + MA * (xPTe1 - XA) + zentx)
  xPTe2 = CInt(XR + MA * (xPTe2 - XA) + zentx)
  yPA = CInt(XR + MA * (yPTa - YA) + zenty)
  yPE = CInt(XR + MA * (yPTe - YA) + zenty)
  p.Line (xPTa1, BY0 - yPA)-(xPTe1, BY0 - yPA), FarbeS
  p.Line (xPTa2, BY0 - yPE)-(xPTe2, BY0 - yPE), FarbeS
  p.Line (xPTa1, BY0 - yPA)-(xPTa2, BY0 - yPE), FarbeS
  p.Line (xPTe1, BY0 - yPA)-(xPTe2, BY0 - yPE), FarbeS
  p.DrawWidth = 1
End If
End Sub   'Plotten_Sys

Public Sub Mastab(ByVal IP As Integer, AZ)
'Mastab berechnen
Dim MZ As Single
Dim ix As Integer, iy As Integer

MZ = -1000000
For ix = 1 To nzx: For iy = 1 To nzy
  If Abs(AZ(ix, iy)) > MZ Then MZ = Abs(AZ(ix, iy))
Next iy, ix
If MZ <= 0.001 Then MZ = 0.001
MS = (XR - 5) / MZ

End Sub   'Mastab

Public Sub Unterschriften(ByVal PLOT As Integer, ByVal IP As Integer)
'Grafikbezeichnungen, Maximalwerte
Dim strZahl As String, Text1 As String

Select Case IP
  Case 1: strZahl = "= " + Format(maxpT, "##0.00 ") + strEHF + "/" + strEHL + ""
  Case 2:
    If strEHL = "m" Then
      strZahl = "= " + Format(maxwz * 1000, "##0.00 mm")
    Else
      strZahl = "= " + Format(maxwz, "##0.00 ") + strEHL
    End If
  Case 3: strZahl = "= " + Format(maxMx, "##0.00 ") + strEHF + strEHL + "/" + strEHL
  Case 4: strZahl = "= " + Format(maxMy, "##0.00 ") + strEHF + strEHL + "/" + strEHL
  Case 5: strZahl = "= " + Format(maxMxy, "##0.00 ") + strEHF + strEHL + "/" + strEHL
  Case 6: strZahl = "= " + Format(maxQx, "##0.00 ") + strEHF + "/" + strEHL
  Case 7: strZahl = "= " + Format(maxQy, "##0.00 ") + strEHF + "/" + strEHL
End Select

Text1 = strLinie(IP) + " max " + " " + strZahl

If PLOT = 1 Then
  p.CurrentX = CInt(SP): p.CurrentY = CInt(ZE)
  p.FontName = "arial": p.FontBold = True
  p.Print Text1
Else
  With frm_Plat1_Chart.Text1
    .FontName = "arial":  .FontBold = True
    .Text = Text1
  End With
End If

End Sub   'Unterschriften


