Attribute VB_Name = "Mod_Plat1_Grafik"


Public Sub Start_Plotten(ByVal Plot As Integer, ByVal IP As Integer)
'UP Plot System und Ergebnisse (v, Q, Mx, My fr FEM6.BAS) ----------
'global: BX0,BY0,SMOD,KARTE$,COLF,COLB (aus UP7800), DNB$
'        N,NS,KE,S*,V*,M*,X*,Y*, PLOT,IP, IP$,LW$,PF$
'lokal:  X,Y,I,J,AX*,AY*,AZ*,X1,X2,Y1,Y2,Z1,Z2,
'        M1-M6,MA,PLOT,A$,AX,AY,Z$,Z, DNX$,DNP$,PIX
Dim I As Integer

Plot = 1

'Koordinaten berechnen
For I = 1 To N
  AY(I) = y(I): AX(I) = x(I)
Next I

'Mastab berechnen
For I = 1 To N
  x = AX(I): y = AY(I)
  AY(I) = (y + 0.4 * x) / 3: AX(I) = (x - 0.4 * y)
Next I
X1 = 0: X2 = 10000: Y1 = 0: Y2 = 10000
For I = 1 To N
  If AX(I) > X1 Then X1 = AX(I)
  If AX(I) < X2 Then X2 = AX(I)
  If AY(I) > Y1 Then Y1 = AY(I)
  If AY(I) < Y2 Then Y2 = AY(I)
Next I

If M4 / (Y1 - Y2) > M3 / (X1 - X2) Then MA = M3 / (X1 - X2) Else MA = M4 / (Y1 - Y2)
For I = 1 To N
  AY(I) = M2 + (AY(I) - Y2) * MA: AX(I) = M1 + (AX(I) - X2) * MA
  If M5 = 1 Then AY(I) = M2 * 2 + M4 - AY(I)
Next I

Call Plotten_1

End Sub

Public Sub Plotten_1(ByVal Plot As Integer, ByVal IP As Integer)
'Zustandslinien
'Bildschirmgraphik  - - - - - - - - - - - - - - - - - - - - - - - - -
XR = 20: M1 = XR: M2 = XR
M3 = BX0 - 2 * XR: M4 = BY0 - 2 * XR
M5 = 1: M6 = XR - 5

Farbe = 15

If IP > 0 Then
  Print "       System"
  Call WNull: Call Plotten_Sys: Exit Sub
End If

Print "       Biegelinie"
Call WNull: Call Plotten_Sys: Farbe = 4
'Ordinaten = Durchbiegung
For I = 1 To NS: For j = 1 To KE: AZ(j, I) = v((j - 1) * 3 + 1, I): Next j, I
Call Mastab: Call Plotten_Ord: Call Plotten_Sys: Farbe = 15

'8725 GoSub 8800
Print "       Querkraftlinie"
Call WNull: Call Plotten_Sys: Farbe = 4
'Ordinaten = Querkrfte
For I = 1 To NS: For j = 1 To KE: AZ(j, I) = M(j, I): Next j, I
Call Mastab: Call Plotten_Ord: Call Plotten_Sys: Farbe = 15

'8745 GoSub 8800
Print "       Biegemomente Mx"
Call WNull: Call Plotten_Sys: Farbe = 4
'Ordinaten = Torsionsmomente
For I = 1 To NS: For j = 1 To KE: AZ(j, I) = M(KE + j, I): Next j, I
Call Mastab: Call Plotten_Ord: Call Plotten_Sys: Farbe = 15

'8765 GoSub 8800
Print "       Biegemomente My"
Call WNull: Call Plotten_Sys: Farbe = 4
'Ordinaten = Biegemomente
For I = 1 To NS: For j = 1 To KE: AZ(j, I) = M(2 * KE + j, I): Next j, I
Call Mastab: Call Plotten_Ord: Call Plotten_Sys: Farbe = 15

8785 GoSub 8800
End Sub

'8799 Rem Pause
'8800 A$ = INKEY$: If A$ = "" Or A$ = Chr$(55) Then GoTo 8800
'8810 CLS:  Return

Public Sub Plotten_Ord()
'Ordinaten zeichnen
For I = 1 To NS
  Line (AX(S(1, I)), AY(S(1, I)))-(AX(S(1, I)), AY(S(1, I)) + AZ(1, I) * MA), Farbe
  Line (AX(S(2, I)), AY(S(2, I)))-(AX(S(2, I)), AY(S(2, I)) + AZ(2, I) * MA), Farbe
Next I
End Sub

Public Sub Plotten_Sys()
'Stabwerksebene zeichnen
Line (1, 1)-(BX0 - 2, BY0 - 2), , B
For I = 1 To NS
  Line (AX(S(1, I)), AY(S(1, I)) + AZ(1, I) * MA)-(AX(S(2, I)), AY(S(2, I)) + AZ(2, I) * MA), Farbe
Next I
End Sub

Public Sub WNull()
'Ordinaten = Null
For I = 1 To NS: For j = 1 To KE: AZ(j, I) = 0: Next j, I
End Sub

Public Sub Mastab()
'Mastab berechnen
Z = 0
For I = 1 To NS: For j = 1 To KE
  If Abs(AZ(j, I)) > Z Then Z = Abs(AZ(j, I))
Next j, I
MA = M6 / Z
End Sub

